// Flag applet for Flag lab
// This generates the applet that runs within the lab description

// Since this should contain the answers, the distributed copy
// has uninteresting methods

// (c) J. Dean Brock, Rebecca F. Bruce, 2001, 2003, 2004
// Department of Computer Science
// University of North Carolina at Asheville

package edu.unca.cs.csci201.LabAids;

import java.awt.Color ;

/**
 * Applet for Flag
 */
public class FlagAppl extends javax.swing.JApplet {
    
    edu.unca.cs.csci201.LabAids.PanelFlag testWindow ;
    
    /**
     * Applet initialization route
     */
    public void init() {
        try {
            java.awt.EventQueue.invokeAndWait(new Runnable() {
                public void run() {
                    initComponents();
                }
            });
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    private void initComponents() {
        testWindow = new edu.unca.cs.csci201.LabAids.PanelFlag(750, 500) ;
        getContentPane().add(testWindow) ;
        testWindow.addPainter(new Haiti(), "Haiti") ;
        testWindow.addPainter(new RedCross(), "Red Cross") ;
        testWindow.addPainter(new checkers(), "Checkers") ;
        testWindow.addPainter(new Ireland(),  "Ireland") ;
        testWindow.addPainter(new NorthCarolina(), "N. C.") ;
        testWindow.addPainter(new USA(), "U.S.A.")  ;
    }

    private static class Haiti implements SpecFlag {
        public int getHeight() { return 20 ; }
        public int getWidth()  { return 30 ; }
        public Color TestFunc(int x, int y) {
            if (y<10)
                return Color.blue ;
            else
                return Color.red ;
        }
    }
    
    private static class RedCross implements SpecFlag {
        private static int myHeight = 20 ;
        private static int myWidth  = 30 ;
        public int getHeight() { return myHeight ; }
        public int getWidth()  { return myWidth ; }
        public Color TestFunc(int x, int y) {
            int diffH = Math.abs(2*y+(1-myHeight))/2 ;
            int diffW = Math.abs(2*x+(1-myWidth))/2 ;
            if ((diffH <= 1 || diffW <= 1) && diffH <= 7 && diffW <= 7)
                return Color.red ;
            else
                return Color.white ;
        }
    }
    
    // Start your modifications here
    private static class checkers implements SpecFlag {
        public int getHeight() { return 8 ; }
        public int getWidth()  { return 8 ; }
        public Color TestFunc(int x, int y) {
            return Color.pink ;
        }
    }
    
    private static class Ireland implements SpecFlag {
        public int getHeight() { return 10 ; }
        public int getWidth()  { return 10 ; }
        public Color TestFunc(int x, int y) {
            return Color.magenta ;
        }
    }
    
    private static class NorthCarolina implements SpecFlag {
        public int getHeight() { return 10 ; }
        public int getWidth()  { return 10 ; }
        public Color TestFunc(int x, int y) {
            return new Color(17*x%256, 13*y%256, 3*x*y%256) ;
        }
    }
    
    private static class USA implements SpecFlag {
        public int getHeight() { return 10 ; }
        public int getWidth()  { return 10 ; }
        public Color TestFunc(int x, int y) {
            return new Color(1776, 13, 50) ;
        }
    }
    
}
